"""Add last modified field

Revision ID: e8d0d9f4962e
Revises: 1a5d70c21bc0
Create Date: 2020-09-02 10:09:29.939599

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
from pscr_common.utils import get_utcnow_with_tzinfo
from sqlalchemy import or_, null

from index_registry.sql.models import Index

revision = 'e8d0d9f4962e'
down_revision = '1a5d70c21bc0'
branch_labels = None
depends_on = None


def upgrade():
    op.add_column('indexes', sa.Column('last_modified', sa.DateTime(timezone=True), nullable=True))
    update_stmt = Index.__table__.update().values({"last_modified": get_utcnow_with_tzinfo(True)}) \
        .where(or_(Index.prefix == 'merging', Index.prefix == 'optimized')) \
        .where(Index.last_modified == null())

    conn = op.get_bind()
    conn.execute(update_stmt)


def downgrade():  # pragma: no cover
    op.drop_column('indexes', 'last_modified')
