import logging
import time

_logger = logging.getLogger(__name__)

def log_and_sleep(message, retries=0, base_sleep=0.1, max_sleep=120):
    """
    Utility function to use for exponential backoff when retrying
    """
    #metrics_registry = global_registry()
    #metrics_registry.counter(f"error.{message}")
    sleep_time = min((2 ** retries) * base_sleep, max_sleep)
    if sleep_time < max_sleep:
        _logger.debug(message)
    else:
        _logger.error(message)

    time.sleep(sleep_time)
    return message